#ifndef __MSTDLIB_H__
#define __MSTDLIB_H__

/*! \defgroup mstdlib_base Base
 *   
 * \code{.c}
 * #include <mstdlib/mstdlib.h>
 * \endcode
 * 
 * Base punctuality such as data structures
 *
 */

/*! \defgroup m_datastructures Data Structures/Algorithms
 *  \ingroup mstdlib_base
 *   Data Structures and Algorithms
 */

#include <mstdlib/base/m_bin.h>
#include <mstdlib/base/m_bincodec.h>
#include <mstdlib/base/m_bit_buf.h>
#include <mstdlib/base/m_bit_parser.h>
#include <mstdlib/base/m_buf.h>
#include <mstdlib/base/m_cache.h>
#include <mstdlib/base/m_cache_strvp.h>
#include <mstdlib/base/m_chr.h>
#include <mstdlib/base/m_decimal.h>
#include <mstdlib/base/m_endian.h>
#include <mstdlib/base/m_fmt.h>
#include <mstdlib/base/m_fs.h>
#include <mstdlib/base/m_getopt.h>
#include <mstdlib/base/m_hashtable.h>
#include <mstdlib/base/m_hash_dict.h>
#include <mstdlib/base/m_hash_multi.h>
#include <mstdlib/base/m_hash_strbin.h>
#include <mstdlib/base/m_hash_stridx.h>
#include <mstdlib/base/m_hash_stru64.h>
#include <mstdlib/base/m_hash_strvp.h>
#include <mstdlib/base/m_hash_u64bin.h>
#include <mstdlib/base/m_hash_u64str.h>
#include <mstdlib/base/m_hash_u64u64.h>
#include <mstdlib/base/m_hash_u64vp.h>
#include <mstdlib/base/m_hash_func.h>
#include <mstdlib/base/m_list.h>
#include <mstdlib/base/m_list_bin.h>
#include <mstdlib/base/m_list_str.h>
#include <mstdlib/base/m_list_u64.h>
#include <mstdlib/base/m_llist.h>
#include <mstdlib/base/m_llist_bin.h>
#include <mstdlib/base/m_llist_str.h>
#include <mstdlib/base/m_llist_u64.h>
#include <mstdlib/base/m_math.h>
#include <mstdlib/base/m_mem.h>
#include <mstdlib/base/m_parser.h>
#include <mstdlib/base/m_queue.h>
#include <mstdlib/base/m_rand.h>
#include <mstdlib/base/m_sort.h>
#include <mstdlib/base/m_state_machine.h>
#include <mstdlib/base/m_str.h>
#include <mstdlib/base/m_textcodec.h>
#include <mstdlib/base/m_time.h>
#include <mstdlib/base/m_types.h>
#include <mstdlib/base/m_utf8.h>

#endif /* __MSTDLIB_H__ */
